/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.tutorial;

/**
 *
 * @author Michael
 */
import java.net.*;
import java.io.*;
import java.util.*;

class Action implements Serializable{
	
	Random generator = new Random();
	
	
	public int ID =-1;
	public int originX =-1;
	public int originY =-1;
	
	
	public int targetX =-1;
	public int targetY =-1;
	
	public int IFF=0;
	
	//Ranges and Costs
	public int maximumRange=3;
	public int minimumRange=0;
	
	public String owningPlayer="";
	
	public String flavourText="An Action";
	public boolean setsDestination=false;
	
	public int orderTurnDuration=1;
	
	public boolean requiresVacantTarget=false;//e.g. for movement/unit generation
	
	public boolean aggressiveAction =false;
	public boolean movementAction=false;
	public boolean defaultAction=false;
	
	
	public int MaxGridSize=25;
	
	public Action(int id, int oX, int oY, int tX, int tY){
		ID =id;
		originX=oX;
		originY=oY;
		targetX=tX;
		targetY=tY;
		if (ID ==1){
			flavourText="Move";
			setsDestination=true;
			requiresVacantTarget=true;
			movementAction=true;
			maximumRange=5;
			orderTurnDuration=2;
		}
		
		if (ID ==11){
			flavourText="Fire Rifles";
			maximumRange=7;
			aggressiveAction=true;
		}
		if (ID ==12){
			flavourText="Fire Machine Gun";
			maximumRange=7;
			orderTurnDuration=1;
			aggressiveAction=true;
		}
		if (ID ==13){
			flavourText="Fire Artillery";
			maximumRange=8;
			orderTurnDuration=1;
			aggressiveAction=true;
		}
		
		
		if (ID ==101){
			flavourText="Create Infantry";
			requiresVacantTarget=true;
			orderTurnDuration=10;
			defaultAction=true;
		}
		if (ID ==102){
			flavourText="Create Machine Gunner";
			requiresVacantTarget=true;
			orderTurnDuration=10;
			defaultAction=true;
		}
		if (ID ==103){
			flavourText="Create Artillery";
			requiresVacantTarget=true;
			orderTurnDuration=10;
			defaultAction=true;
		}
	}
	
	public void deadUnitCheck(Unit unitToUse){
		
		if (unitToUse.currentHealth <=0){
			unitToUse.markedForDeath=true;
		}
	}
	
        public Unit getUnit(GameState gsToUse, int x, int y){
            
            for (int j = 0; j < gsToUse.zoneArray.size(); ++j ) {
                    if (gsToUse.zoneArray.get(j).occupyingUnit!=null){
                        if (gsToUse.zoneArray.get(j).xPos == x && gsToUse.zoneArray.get(j).yPos ==y){
                            return gsToUse.zoneArray.get(j).occupyingUnit;
                        }
                    }
            }
            return null;
        }
        
        public void setUnit(Unit unitToSet, GameState gsToUse, int x, int y){
            for (int j = 0; j < gsToUse.zoneArray.size(); ++j ) {
                    
                    if (gsToUse.zoneArray.get(j).xPos == x && gsToUse.zoneArray.get(j).yPos ==y){
                        gsToUse.zoneArray.get(j).occupyingUnit= unitToSet;
                    }
                    
            }
            
        }
        
	public void attemptAction(GameState gsToUse){
		
	
            if (ID==1){//move
                if (getUnit(gsToUse, originX, originY) !=null){
                    Unit originalUnit=getUnit(gsToUse, originX, originY);
                    originalUnit.setCoords(targetX, targetY);
                    setUnit(originalUnit,gsToUse,targetX,targetY);
                    setUnit(null,gsToUse,originX, originY);//This may cause problems.

                }				
            }


            if (ID ==11){//attack
                if (getUnit(gsToUse, targetX, targetY)!=null){
                        int damage=30+generator.nextInt(10);
                        if (getUnit(gsToUse, targetX, targetY).heavyUnitType ==true){
                                damage =damage+30;				
                        }
                        getUnit(gsToUse, targetX, targetY).currentHealth = getUnit(gsToUse, targetX, targetY).currentHealth - damage;
                        deadUnitCheck(getUnit(gsToUse, targetX, targetY));
                }
            }
            if (ID ==12){//attack
                if (getUnit(gsToUse, targetX, targetY)!=null){
                        int damage=30+generator.nextInt(10);
                        if (getUnit(gsToUse, targetX, targetY).lightUnitType ==true){
                                damage =damage+30;				
                        }
                        getUnit(gsToUse, targetX, targetY).currentHealth = getUnit(gsToUse, targetX, targetY).currentHealth - damage;
                        deadUnitCheck(getUnit(gsToUse, targetX, targetY));
                }
            }
            if (ID ==13){//attack
                if (getUnit(gsToUse, targetX, targetY)!=null){
                        int damage=30+generator.nextInt(10);
                        if (getUnit(gsToUse, targetX, targetY).nestUnitType ==true){
                                damage =damage+30;				
                        }
                        getUnit(gsToUse, targetX, targetY).currentHealth = getUnit(gsToUse, targetX, targetY).currentHealth - damage;
                        deadUnitCheck(getUnit(gsToUse, targetX, targetY));
                }
            }



            if (ID==101){//spawn infantry
                Unit spawnedUnit = new Unit(1,owningPlayer);
                if (getUnit(gsToUse, originX, originY) !=null){
                    if (getUnit(gsToUse, originX, originY).status.equals("Aggressive")){
                        spawnedUnit.status="Aggressive";               
                    }
                }
                spawnedUnit.ordersProcessed=true;   
                setUnit(spawnedUnit,gsToUse,targetX,targetY);                    
                getUnit(gsToUse, targetX, targetY).IFF=IFF;
                getUnit(gsToUse, targetX, targetY).setCoords(targetX,targetY);

            }
            if (ID==102){//spawn MG		
                Unit spawnedUnit = new Unit(2,owningPlayer);
                if (getUnit(gsToUse, originX, originY) !=null){
                    if (getUnit(gsToUse, originX, originY).status.equals("Aggressive")){
                        spawnedUnit.status="Aggressive";               
                    }
                }
                spawnedUnit.ordersProcessed=true;
                setUnit(spawnedUnit,gsToUse,targetX,targetY);                    
                getUnit(gsToUse, targetX, targetY).IFF=IFF;
                getUnit(gsToUse, targetX, targetY).setCoords(targetX,targetY);
            }
            if (ID==103){//spawn Artillery		
                Unit spawnedUnit = new Unit(3,owningPlayer);
                if (getUnit(gsToUse, originX, originY) !=null){
                    if (getUnit(gsToUse, originX, originY).status.equals("Aggressive")){
                        spawnedUnit.status="Aggressive";               
                    }
                }
                spawnedUnit.ordersProcessed=true;
                setUnit(spawnedUnit,gsToUse,targetX,targetY);                    
                getUnit(gsToUse, targetX, targetY).IFF=IFF;
                getUnit(gsToUse, targetX, targetY).setCoords(targetX,targetY);
            }
		
	}
	
        public Location getLocation(GameState gsToUse, int x, int y){
            if (gsToUse!=null){
                for (int j = 0; j < gsToUse.zoneArray.size(); ++j ) {
                        
                    if (gsToUse.zoneArray.get(j).xPos == x && gsToUse.zoneArray.get(j).yPos ==y){
                        return gsToUse.zoneArray.get(j);
                    }
                        
                }
                
            }
            return null;
        }
        
	public boolean isActionPossible(GameState gsToUse){
		boolean possible =true;
		if (requiresVacantTarget==true){
                        if (getLocation(gsToUse,targetX,targetY)!=null){
                            if (getLocation(gsToUse,targetX,targetY).occupyingUnit!=null){
                                possible=false;
                            }
                        }			
		}
		
		return possible;
	}	
	
	public void setOwningPlayer(String playerID){
		owningPlayer = playerID;
		
	}
	
	public void setIFF(int iff){
		IFF=iff;
	}
	
	public void setOrigin(int X, int Y){
		originX=X;
		originY=Y;
	}
	
	public void setTarget(int X, int Y){
		targetX=X;
		targetY=Y;
	}
}

