/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.tutorial;

/**
 *
 * @author Michael
 */
import java.io.*;
import java.net.*;
import java.text.SimpleDateFormat;
import java.util.*;


import java.awt.Color;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.util.HashSet;
import java.util.Set;

import javax.swing.JButton;
import javax.swing.JToolBar;

import org.geotools.data.FileDataStore;
import org.geotools.data.FileDataStoreFinder;
import org.geotools.data.simple.SimpleFeatureCollection;
import org.geotools.data.simple.SimpleFeatureIterator;
import org.geotools.data.simple.SimpleFeatureSource;
import org.geotools.factory.CommonFactoryFinder;
import org.geotools.geometry.jts.ReferencedEnvelope;
import org.geotools.map.FeatureLayer;
import org.geotools.map.Layer;
import org.geotools.map.MapContent;
import org.geotools.styling.FeatureTypeStyle;
import org.geotools.styling.Fill;
import org.geotools.styling.Graphic;
import org.geotools.styling.Mark;
import org.geotools.styling.Rule;
import org.geotools.styling.Stroke;
import org.geotools.styling.Style;
import org.geotools.styling.StyleFactory;
import org.geotools.styling.Symbolizer;
import org.geotools.swing.JMapFrame;
import org.geotools.swing.data.JFileDataStoreChooser;
import org.geotools.swing.event.MapMouseEvent;
import org.geotools.swing.tool.CursorTool;
import org.opengis.feature.simple.SimpleFeature;
import org.opengis.feature.type.GeometryDescriptor;
import org.opengis.filter.Filter;
import org.opengis.filter.FilterFactory2;
import org.opengis.filter.FilterFactory;
import org.opengis.filter.identity.FeatureId;
import org.geotools.map.MapViewport;
import org.geotools.renderer.GTRenderer;
import org.geotools.renderer.lite.StreamingRenderer;

import org.geotools.filter.AreaFunction;

import org.opengis.geometry.BoundingBox;

import org.opengis.referencing.operation.MathTransform;

import org.geotools.referencing.crs.DefaultGeographicCRS;
        
import com.vividsolutions.jts.geom.LineString;
import com.vividsolutions.jts.geom.MultiLineString;
import com.vividsolutions.jts.geom.MultiPolygon;
import com.vividsolutions.jts.geom.Polygon;
import com.vividsolutions.jts.geom.Geometry;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JOptionPane;


public class Server {
	// a unique ID for each connection
	private static int uniqueId;
	// an ArrayList to keep the list of the Client
	private ArrayList<ClientThread> ClientThreadList;
	
	private ArrayList<String> ClientNameList;
	
	private ArrayList<Location> temporaryPossibleTargets = new ArrayList();
	
	private ArrayList<Action> temporaryPossibleActions = new ArrayList();
	
	private JMapFrame mapFrame;
        
	Random generator = new Random();
	
	
	public GameState gs = new GameState();
	
	
	private SimpleDateFormat sdf;	
	private int port;	
	private boolean keepGoing;
	
	int ServerCounter;
	
	int totalConnections=0;
	int lockedConnections=0;
	
	String StringToSend = "";
	
	public int MaxGridSize=25;
	
        ArrayList<SimpleFeature> adjacentFeatureArray = new ArrayList();
        ArrayList<Location> adjacentLocationArray = new ArrayList();
        
        private StyleFactory sf = CommonFactoryFinder.getStyleFactory();
        
        private SimpleFeatureSource featureSource;
        private enum GeomType { POINT, LINE, POLYGON };
        private String geometryAttributeName;
        private GeomType geometryType;
        
        
	private void display(String msg) {
		
		System.out.println(sdf.format(new Date()) + " " + msg);
		
	}
	
	public Server(int port) {
		
		// the port
		this.port = port;
		// to display hh:mm:ss
		sdf = new SimpleDateFormat("HH:mm:ss");
		// ArrayList for the Client list
		ClientThreadList = new ArrayList<ClientThread>();
		ClientNameList =  new ArrayList<String>();
		
		
		
	}

	public void start() {
		keepGoing = true;
		
		try
		{
			//Create new server socket
			ServerSocket serverSocket = new ServerSocket(port);
			
			//wait for connections.
			while(keepGoing)
			{
				//Get local address and print to console.
				InetAddress address = InetAddress.getLocalHost();
				System.out.println("CURRENT IP ADDRESS: " + address.getHostAddress());
				display("Server waiting for Clients on port " + port + ".");
				display("Currently Hosting " + ClientThreadList.size() + " connections.");

				Socket socket = serverSocket.accept();
				// accept connection
				
				if(keepGoing!=true){
					break;
				}
				
				System.out.println("Server socket opened");
				//make a new thread for anything connecting to the socket.
				ClientThread t = new ClientThread(socket);  // make a thread of it
				
				System.out.println("Client socket opened");
				//add to the arraylist of threads.
				ClientThreadList.add(t);
				t.start();
				System.out.println("Thread Started");
			}
			// I was asked to stop
			try {	
				//attempt to close sockets.
				serverSocket.close();
				for(int i = 0; i < ClientThreadList.size(); ++i) {
					ClientThread tc = ClientThreadList.get(i);
					try {
					tc.sInput.close();
					tc.sOutput.close();
					tc.socket.close();
					
					}
					catch(IOException ioE) {
						display("Exception when closing threads: " + ioE);
					}
				}
			}
			catch(Exception e) {
				display("Exception closing the server and clients: " + e);
			}
		}
		// something went bad
		catch (IOException e) {
		String msg = sdf.format(new Date()) + " Exception on new ServerSocket: " + e + "\n";
			display(msg);
		}
	}

	protected void stop() {
		keepGoing = false;
		
		
	}

	private synchronized void broadcast(String message) {
		
		
		String messageLf = sdf.format(new Date()) + " " + message + "\n";
		//display locally.
		System.out.print(messageLf);
		
		//Make new object to send to clients.
		NetworkObject objectToBroadcast = new NetworkObject(new ChatMessage(1,messageLf));
		//NetworkObject ObjectToBroadcast = null;
		
		//reverse loop to catch disconnected clients.
		for(int i = ClientThreadList.size(); --i >= 0;) {
			ClientThread ct = ClientThreadList.get(i);
  
			//write to clients, remove them if failed.
			if(!ct.writeMsg(objectToBroadcast)) {
				ClientThreadList.remove(i);
				display("Disconnected Client " + ct.username + " removed from list.");
			}
		}
	}
	
	private synchronized void checkTurnsLockedIn(){
		
		boolean allLocked=true;
		for(int i = ClientThreadList.size(); --i >= 0;) {
			ClientThread ct = ClientThreadList.get(i);
			
			if(ct.lockedIn==false) {
				
				allLocked=false;
				
			}
		}
	
		if (allLocked ==true){
                        //System.out.println("Advancing");
			advanceTurn();	
                        
		}
	
	}
	
	private synchronized Unit getNearestTarget(Unit unitToUse){
		int smallestDistance=50000;
		Unit unitToStore =null;
		int j,i;
		
		if (unitToUse!=null){
                    for ( j = 0; j < gs.zoneArray.size(); ++j){
                        if (gs.zoneArray.get(j).occupyingUnit!=null){
                            Unit potentialTarget = gs.zoneArray.get(j).occupyingUnit;
                            if (potentialTarget!= unitToUse){
                                if (potentialTarget.IFF != unitToUse.IFF){//enemy unit
                                    int distance = (int)DistanceBetweenTwoPoints(potentialTarget.X, potentialTarget.Y, unitToUse.X,unitToUse.Y);									
                                    if (distance < smallestDistance){
                                        unitToStore = gs.zoneArray.get(j).occupyingUnit;
                                        smallestDistance=distance;
                                    }
                                }
                            }				
			}
                    }
		}		
		return unitToStore;					
	}
	
	private synchronized void getPossibleEmptyLocations(Unit unitToUse, Unit targetUnit, Action actionToUse){
		temporaryPossibleTargets.clear();
		
                int j,i;
		for ( j = 0; j < adjacentLocationArray.size(); ++j ) {
                    if (adjacentLocationArray.get(j).occupyingUnit==null){
                        temporaryPossibleTargets.add(adjacentLocationArray.get(j));
                    }
                }		
	
	}
	
	public boolean validCoordinates(int X, int Y){
		if (X >= 0 && X < MaxGridSize && Y >=0 && Y <MaxGridSize){
			return true;
		
		}
		return false;
	
	}
	
        public boolean inRange(Action actionToUse, SimpleFeature originFeature,SimpleFeature targetFeature){

                if (adjacentFeatureArray.contains(targetFeature)){
                    return true;            
                }else{
                    return false;                
                }
        }
        
        private Style createDefaultStyle() {
            Rule rule = sf.createRule();

            FeatureTypeStyle fts = sf.createFeatureTypeStyle();
            fts.rules().add(rule);

            Style style = sf.createStyle();
            style.featureTypeStyles().add(fts);
            return style;
        }
        
        public SimpleFeature getContainingFeature(Unit unitToFind){
            for (int j = 0; j < gs.zoneArray.size(); ++j){
                if (gs.zoneArray.get(j).occupyingUnit!=null){
                    if (gs.zoneArray.get(j).occupyingUnit == unitToFind){
                        return gs.zoneArray.get(j).featureStored;
                    }
                }
            }
            
            return null;
        }
        
        public void generateAdjacentFeatures(SimpleFeature featureToUse){
            adjacentFeatureArray.clear();
            adjacentLocationArray.clear();
            FilterFactory2 ff = CommonFactoryFinder.getFilterFactory2();
            
            try {

                if (featureToUse!=null){
                    //get the geometry data of the target country.
                    AreaFunction areaHandler = new AreaFunction();

                    Geometry geom = (Geometry) featureToUse.getDefaultGeometry();
                    
                    if (areaHandler.getArea(geom) >30){
                    
                        MapContent map = new MapContent();
                        map.setTitle("Feature selection tool example");
                        mapFrame = new JMapFrame(map);
                        Style style = createDefaultStyle();
                        
                        mapFrame.getMapPane().setMapContent(map);
                        
                        Layer layer = new FeatureLayer(featureSource, style);
                        
                        map.addLayer(layer);
                        
                        BoundingBox CountryBox = featureToUse.getBounds();
                        
                        Rectangle screenRect2 = new Rectangle((int)(CountryBox.getMinX()), (int)(CountryBox.getMinY()), (int)(CountryBox.getWidth()), (int)(CountryBox.getHeight()));
                        
                        ReferencedEnvelope bbox2 = new ReferencedEnvelope(screenRect2, mapFrame.getMapContent().getCoordinateReferenceSystem());




                        
                        try {
                            for (int j = 0; j < gs.zoneArray.size(); ++j ) {
                                SimpleFeature feature = gs.zoneArray.get(j).featureStored;
                                BoundingBox CountryBoxToCheck = feature.getBounds();
                                
                                Rectangle screenRect3 = new Rectangle((int)(CountryBoxToCheck.getMinX()), (int)(CountryBoxToCheck.getMinY()), (int)(CountryBoxToCheck.getWidth()), (int)(CountryBoxToCheck.getHeight()));
                                ReferencedEnvelope bbox3 = new ReferencedEnvelope(screenRect3, mapFrame.getMapContent().getCoordinateReferenceSystem());

                                Filter overlapFilter = ff.overlaps(ff.literal(bbox2), ff.literal(bbox3)); 
                                Filter withinFilter =ff.contains(ff.literal(bbox3), ff.literal(bbox2));
                                Filter withoutFilter=ff.contains(ff.literal(bbox2), ff.literal(bbox3));
                                Filter touchFilter = ff.touches(ff.literal(bbox2), ff.literal(bbox3));
                                Filter twoFilters = ff.or(overlapFilter, withinFilter);
                                Filter threeFilters = ff.or(twoFilters, touchFilter);
                                Filter allFilters = ff.or(threeFilters, withoutFilter);


                                if( allFilters.evaluate( feature ) ){
                                    Geometry geom2 = (Geometry) feature.getDefaultGeometry();
                    
                                    if (areaHandler.getArea(geom2) >30){
                                        adjacentLocationArray.add(gs.zoneArray.get(j));
                                        adjacentFeatureArray.add(feature);
                                        
                                    }
                                    
                                }

                            }

                        } finally {
                            
                        }
                        
                    }
                }else{
                    System.out.println("No Country Found");
                }
            } catch (Exception ex) {
                ex.printStackTrace();
                return;
            }
            
            
        }
        
	private synchronized void createNewOrder(Unit unitToUse, Unit targetUnit){
		
                generateAdjacentFeatures(getContainingFeature(unitToUse));
            
		int Distance = (int)DistanceBetweenTwoPoints(targetUnit.X, targetUnit.Y, unitToUse.X,unitToUse.Y);
		//total distance.
		
		
		boolean orderMade=false;
		
		//check if in range of aggressive actions. -attempt a basic attack.
		int j,i,m;
		for ( j = 0; j < unitToUse.unitActions.size(); ++j ) {
                    if (unitToUse.unitActions.get(j).aggressiveAction==true){
                        for ( i = 0; i < adjacentLocationArray.size(); ++i ) {
                            if (adjacentLocationArray.get(i).occupyingUnit==targetUnit){

                                Action orderToSet = new Action(unitToUse.unitActions.get(j).ID,unitToUse.X,unitToUse.Y,targetUnit.X,targetUnit.Y);
                                orderToSet.setOwningPlayer(unitToUse.owningPlayer);
                                orderToSet.setIFF(unitToUse.IFF);			
                                unitToUse.standingOrders.add(orderToSet);
                                orderMade=true;
                            }
                        }				
                    }	
		}
		
		// else move closer or find somewhere to move to.
		if (orderMade==false){			
			
			for ( j = 0; j < unitToUse.unitActions.size(); ++j ) {
				if (unitToUse.unitActions.get(j).movementAction==true){
					
						
					Location locationToUse =null;	
					
					temporaryPossibleTargets.clear();						
					getPossibleEmptyLocations(unitToUse, targetUnit, unitToUse.unitActions.get(j));
					
					int ShortestDistance=5000;
					
					for ( i = 0; i < temporaryPossibleTargets.size(); ++i ) {
						if ( (int)DistanceBetweenTwoPoints(targetUnit.X, targetUnit.Y, temporaryPossibleTargets.get(i).xPos,temporaryPossibleTargets.get(i).yPos) < ShortestDistance){
							ShortestDistance = (int)DistanceBetweenTwoPoints(targetUnit.X, targetUnit.Y, temporaryPossibleTargets.get(i).xPos,temporaryPossibleTargets.get(i).yPos);
							locationToUse = temporaryPossibleTargets.get(i);							
						}
					}					
					
					if (locationToUse!=null){//there are none closer, or no new locations.
						
                                            Action orderToSet = new Action(unitToUse.unitActions.get(j).ID,unitToUse.X,unitToUse.Y,locationToUse.xPos,locationToUse.yPos);
                                            orderToSet.setOwningPlayer(unitToUse.owningPlayer);		
                                            orderToSet.setIFF(unitToUse.IFF);			
                                            unitToUse.standingOrders.add(orderToSet);
                                            orderMade=true;	
						
					}else{
                                            if (temporaryPossibleTargets.size() > 0){
                                                locationToUse = temporaryPossibleTargets.get(generator.nextInt(temporaryPossibleTargets.size()));
                                                if (locationToUse!=null){//pick a random location to move to.
                                                    //Could replace this with an A* search.
                                                    Action orderToSet = new Action(unitToUse.unitActions.get(j).ID,unitToUse.X,unitToUse.Y,locationToUse.xPos,locationToUse.yPos);
                                                    orderToSet.setOwningPlayer(unitToUse.owningPlayer);		
                                                    orderToSet.setIFF(unitToUse.IFF);			
                                                    unitToUse.standingOrders.add(orderToSet);
                                                    orderMade=true;	
                                                    
                                                }
                                            }
                                        }					
				}	
			}
		}
		
		// else do default action
		if (orderMade==false){
					
                    temporaryPossibleActions.clear();

                    for ( j = 0; j < unitToUse.unitActions.size(); ++j ) {
                            if (unitToUse.unitActions.get(j).defaultAction==true){
                                    temporaryPossibleActions.add(unitToUse.unitActions.get(j));					
                            }
                    }

                    //randomly choose
                    if (temporaryPossibleActions.size()>0){
                        Action actionToUse = temporaryPossibleActions.get(generator.nextInt(temporaryPossibleActions.size()));

                        //else try to pick counter to closest unit.
                        if (unitToUse.AILevel==2){
                                if (targetUnit.ID==1){
                                        temporaryPossibleActions.get(0);
                                }else if (targetUnit.ID==2){
                                        temporaryPossibleActions.get(1);
                                }else{
                                        temporaryPossibleActions.get(2);
                                }

                        }

                        Location locationToUse =null;			
                        temporaryPossibleTargets.clear();						
                        getPossibleEmptyLocations(unitToUse, targetUnit, actionToUse);

                        int ShortestDistance=5000;

                        for ( i = 0; i < temporaryPossibleTargets.size(); ++i ) {
                                if ( (int)DistanceBetweenTwoPoints(targetUnit.X, targetUnit.Y, temporaryPossibleTargets.get(i).xPos,temporaryPossibleTargets.get(i).yPos) < ShortestDistance){
                                        ShortestDistance = (int)DistanceBetweenTwoPoints(targetUnit.X, targetUnit.Y, temporaryPossibleTargets.get(i).xPos,temporaryPossibleTargets.get(i).yPos);
                                        locationToUse = temporaryPossibleTargets.get(i);				
                                }

                        }

                        if (locationToUse!=null){


                            int turnDuration=0;

                            boolean actionPossible=true;
                            Action orderToSet = new Action(actionToUse.ID,unitToUse.X,unitToUse.Y,locationToUse.xPos,locationToUse.yPos);
                            for (i = 0; i < unitToUse.standingOrders.size(); ++i ) {
                                    turnDuration =turnDuration + unitToUse.standingOrders.get(i).orderTurnDuration;
                            }
                            if (unitToUse.maximumOrderQueueSize < (turnDuration+orderToSet.orderTurnDuration)){
                                    actionPossible=false;							
                            }				
                            if (actionPossible==true){
                                    orderToSet.setOwningPlayer(unitToUse.owningPlayer);
                                    orderToSet.setIFF(unitToUse.IFF);					
                                    unitToUse.standingOrders.add(orderToSet);
                                    orderMade=true;
                            }		

                        }
                    }
                    
			
		}
		
	}
	
	public Unit getIdleAIUnitByTeam(int teamID){
                //returns a idle ai unit for this specific team.
		Unit unitToReturn =null;
		int j,i,m;
                for ( j = 0; j < gs.zoneArray.size(); ++j){
                    if (gs.zoneArray.get(j).occupyingUnit!=null){
                        Unit unitToUse = gs.zoneArray.get(j).occupyingUnit;
                        
			if (unitToUse.status.equals("Aggressive")){//ai orders
                                
                                
                                if (unitToUse.ordersProcessed==false){
                                        if (unitToUse.IFF ==teamID){

                                                return unitToUse;
                                        }
                                }
                        }			
                    }
                }
                
		return unitToReturn;
	}
	
	private synchronized void advanceTurn(){
		//all orders have been updated so that local version of units' orders are accurate.
		//now just need to process turn progression.
		gs.turnNumber++;
		String logUpdates ="Turn "+ gs.turnNumber+":\n";
		
		//proceed through all units and process their orders.
		int j,i,m;
		int teamID=1+generator.nextInt(2);
		
		//process AI units.
                ////////////////////////////////////////////////////////////////////////
		Unit unitToUse = getIdleAIUnitByTeam(teamID);
		while (unitToUse!=null){
						
			Unit unitToTarget = getNearestTarget(unitToUse);
			if (unitToTarget !=null){
				createNewOrder(unitToUse, unitToTarget);																
                                
                        }
                        
			//process orders
			for ( m = 0; m < unitToUse.standingOrders.size(); ++m ) {
				if (unitToUse.ordersProcessed==false){// in case he was killed.
										
					Action orderToProcess= unitToUse.standingOrders.get(m);
					if (orderToProcess.isActionPossible(gs)){
						orderToProcess.attemptAction(gs);
                                                for ( i = 0; i < gs.zoneArray.size(); ++i ) {
                                                    if ( gs.zoneArray.get(i).occupyingUnit!=null){
                                                        if ( gs.zoneArray.get(i).occupyingUnit.isDead()==true){
                                                            logUpdates =logUpdates + gs.zoneArray.get(i).occupyingUnit.flavourText+"("+gs.zoneArray.get(i).occupyingUnit.IFF +") was killed. "+":\n";
                                                            gs.zoneArray.get(i).occupyingUnit=null;
                                                        }
                                                    }
                                                }						
						
					}else{
						logUpdates = logUpdates + unitToUse.flavourText +" was unable to "+ orderToProcess.flavourText+"\n";
					}
					unitToUse.standingOrders.remove(m);
					m--;
				}
			}								
			unitToUse.standingOrders.clear();							
			unitToUse.ordersProcessed=true;
			
			//alternate between teams
			if (teamID==1){
				teamID=2;
			}else{
				teamID=1;
			}			
			unitToUse = getIdleAIUnitByTeam(teamID);
			if (unitToUse==null){//if one team has no more units, do the other.
				if (teamID==1){
					teamID=2;
				}else{
					teamID=1;
				}			
				unitToUse = getIdleAIUnitByTeam(teamID);
			}
		}
			
						
						
		
                
                for ( j = 0; j < gs.zoneArray.size(); ++j ) {
                    if (gs.zoneArray.get(j).occupyingUnit!=null){
                        
                        unitToUse = gs.zoneArray.get(j).occupyingUnit;
                        if (!unitToUse.status.equals("Aggressive")){
                            
                            for ( m = 0; m < unitToUse.standingOrders.size(); ++m ) {
                                
                                if (unitToUse.markedForDeath ==false && unitToUse.ordersProcessed==false){// in case he was killed.

                                            
                                        Action orderToProcess= unitToUse.standingOrders.get(m);
                                        if (orderToProcess.isActionPossible(gs)){

                                                orderToProcess.attemptAction(gs);
                                        }else{
                                                logUpdates = logUpdates + unitToUse.flavourText +" was unable to "+ orderToProcess.flavourText+"\n";
                                        }
                                        unitToUse.standingOrders.remove(m);
                                        m--;
                                }
                            }
                            unitToUse.standingOrders.clear();
                            //could then go on to generate new orders here based on standing orders.
                            unitToUse.ordersProcessed=true;
                            
                        }
                    }
                }
                
                
                
		//remove dead units.
		for ( j = 0; j < gs.zoneArray.size(); ++j ) {
                    if (gs.zoneArray.get(j).occupyingUnit!=null){
                        
                        unitToUse = gs.zoneArray.get(j).occupyingUnit;
						
                        if (unitToUse.markedForDeath==true || unitToUse.isDead()==true){
                                logUpdates =logUpdates + unitToUse.flavourText+"("+unitToUse.IFF +") was killed. "+":\n";
                                unitToUse =null;							
                        }
                    }
			
		}
		
		//set AI units to await new orders.
		for ( j = 0; j < gs.zoneArray.size(); ++j ) {
                    if (gs.zoneArray.get(j).occupyingUnit!=null){
                        
                        unitToUse = gs.zoneArray.get(j).occupyingUnit;
                        
                        unitToUse.ordersProcessed=false;
                        
                        
                        unitToUse.setCoords(gs.zoneArray.get(j).xPos,gs.zoneArray.get(j).yPos);					
                    }
		}
		
		//victory check
		boolean team1Found =false;
		boolean team2Found =false;
                
                for ( j = 0; j < gs.zoneArray.size(); ++j ) {
                    if (gs.zoneArray.get(j).occupyingUnit!=null){
                        
                        if (gs.zoneArray.get(j).occupyingUnit.IFF==1){
                                team1Found=true;
                        }else if (gs.zoneArray.get(j).occupyingUnit.IFF==2){
                                team2Found=true;
                        }                        				
                    }
		}
                
		if (team1Found ==true && team2Found==false){
			logUpdates = logUpdates + "Team 1 is victorious.";
		}else if (team1Found ==false && team2Found==true){
			logUpdates = logUpdates + "Team 2 is victorious.";
		}
		
		
		updateBroadcast(logUpdates);
	}

	synchronized void removePlayer(int id) {
		
		for(int i = 0; i < ClientThreadList.size(); ++i) {
			ClientThread ct = ClientThreadList.get(i);			
			if(ct.id == id) {
				ClientThreadList.remove(i);
				return;
			}
		}
	}
	
	public void addNewStartingUnit(String username, int clientTeamNumber, int id, boolean AI){
            boolean spacesRemaining=false;

            for (int  j = 0; j < gs.zoneArray.size(); ++j ) {
                if (gs.zoneArray.get(j).occupyingUnit==null){
                    spacesRemaining=true;

                }
            }
            if (gs.zoneArray.size() >0 && spacesRemaining==true){
                boolean UnitAdded=false;
                int Attempts=0;
                while (UnitAdded==false && Attempts <100){
                    int valueToAttempt = generator.nextInt(gs.zoneArray.size());
                    Location locationToAttempt = gs.zoneArray.get(valueToAttempt);
                    if (locationToAttempt.occupyingUnit==null){
                        locationToAttempt.occupyingUnit = new Unit(101,username);
                        locationToAttempt.occupyingUnit.IFF = clientTeamNumber;
                        locationToAttempt.occupyingUnit.setCoords(gs.zoneArray.get(valueToAttempt).xPos,gs.zoneArray.get(valueToAttempt).yPos);
                        if (AI==true){
                            locationToAttempt.occupyingUnit.status ="Aggressive";                            
                        }
                        UnitAdded=true;
                    }
                    Attempts++;
                    
                }
                
            }
            
	}
	
	public static void main(String[] args) {
                
		JPanel SelectionPanel = new JPanel();
                
                SelectionPanel.add(new JLabel("Number of Team 1 AI Players:"));
                String[] AIValues = { "0","1", "2","3","4","5","6","7","8"};			
                JComboBox AIList = new JComboBox(AIValues);			
                SelectionPanel.add(AIList);
                
                SelectionPanel.add(new JLabel("Number of Team 2 AI Players:"));
                String[] AIValues2 = { "0","1", "2","3","4","5","6","7","8"};			
                JComboBox AIList2 = new JComboBox(AIValues2);			
                SelectionPanel.add(AIList2);
                
                int Team1AIs=0;
                int Team2AIs=0;
                
                int result = JOptionPane.showConfirmDialog(null, SelectionPanel,"Connection", JOptionPane.OK_CANCEL_OPTION);
                if (result == JOptionPane.OK_OPTION) {
                    Team1AIs = AIList.getSelectedIndex();
                    Team2AIs = AIList2.getSelectedIndex();
                    
                    
                }
                File file = JFileDataStoreChooser.showOpenFile("shp", null);
                if (file == null) {
                    return;
                }else{
                    
                    
                }
                
                
                
		int portNumber = 1500;
		switch(args.length) {
			case 1:
				try {
					portNumber = Integer.parseInt(args[0]);
				}
				catch(Exception e) {
					System.out.println("Invalid port number.");
					return;
				}
			case 0:
				break;
			default:
				System.out.println("Too many server arguments. ");
				return;

		}
		Server server = new Server(portNumber);
                server.setupMap(file,Team1AIs,Team2AIs);
		server.start();
	}
	
        public void setupMap(File file, int Team1AIs, int Team2AIs){
            try{
                FileDataStore store = FileDataStoreFinder.getDataStore(file);
                featureSource = store.getFeatureSource();
                
            }catch(Exception e){
                System.out.println(e);
            }
            setGeometry();
            gs = new GameState();
            gs.setMapLocations(featureSource);
            
            int NumberOfAIs=1;
            
            for (int i = 0; i < Team1AIs; ++i ) {
                addNewStartingUnit("AI "+ NumberOfAIs, 1, 101, true);           
                NumberOfAIs++;
            }
             for (int i = 0; i < Team2AIs; ++i ) {
                addNewStartingUnit("AI "+ NumberOfAIs, 2, 101, true);           
                NumberOfAIs++;
            } 
            
        }
        
	public void updateBroadcast(String logUpdates){
		
		
		//broadcast an update of the gamestate to all players.
		
		NetworkObject objectToBroadcast = new NetworkObject(new ChatMessage(11,"Updated game sent: "+ sdf.format(new Date()) ));
		
		objectToBroadcast.turnResults = logUpdates;
		
		//objectToBroadcast.gsToSend=gs;
		compileUnitsForTransfer(objectToBroadcast);
                
                
		for(int i = ClientThreadList.size(); --i >= 0;) {
			ClientThread ct = ClientThreadList.get(i);
			ct.lockedIn=false;
			lockedConnections--;
							
			//write to clients, remove them if failed.
			if(!ct.writeMsg(objectToBroadcast)) {
				ClientThreadList.remove(i);
				display("Disconnected Client " + ct.username + " removed from list.");
			}
		}
                
                //System.out.println(lockedConnections+" ");
	
	}
	
        public void compileUnitsForTransfer(NetworkObject objectToBroadcast){
            int j,i;
                        
            for ( i = 0; i < gs.zoneArray.size(); ++i ) {
                if (gs.zoneArray.get(i).occupyingUnit!=null){
                    objectToBroadcast.unitTransferArray.add(gs.zoneArray.get(i).occupyingUnit);
                    
                }

            }
            
            
        }
        
	public void receiveGameUpdate(ArrayList<Unit> receivedUnits,String sender){
		//System.out.println("Received "+receivedUnits.size()+" units from "+ sender);
		//get orders that were changed by the Client for each unit, and overwrite the orders held on the server for that specific unit.
		int j,i;
		for ( j = 0; j < receivedUnits.size(); ++j ) {
                        //System.out.println(receivedUnits.get(j).X);
			for ( i = 0; i < gs.zoneArray.size(); ++i ) {                                
				if (gs.zoneArray.get(i).occupyingUnit !=null){
                                        if (receivedUnits.get(j).X == gs.zoneArray.get(i).xPos && receivedUnits.get(j).Y == gs.zoneArray.get(i).yPos ){
                                            if (gs.zoneArray.get(i).occupyingUnit.owningPlayer.equals(sender)){
                                                    updateUnitOrders(receivedUnits.get(j), gs.zoneArray.get(i).occupyingUnit);
                                            }  
                                        }
				}
			}
		}		
	}						
	
        public void updateUnitOrders(Unit newUnit, Unit oldUnit){
	
				
            if (newUnit!=null&& oldUnit!=null){
                    oldUnit.standingOrders=newUnit.standingOrders;
                    oldUnit.destinationX=newUnit.destinationX;
                    oldUnit.destinationY=newUnit.destinationY;
            }
	}
        
	public void updateUnitOrders(Unit unitToUse, int x, int y){
	
		if (gs.Map[x][y]!=null){
			if (gs.Map[x][y].occupyingUnit!=null){			
				if (unitToUse!=null){
					gs.Map[x][y].occupyingUnit.standingOrders=unitToUse.standingOrders;
					gs.Map[x][y].occupyingUnit.destinationX=unitToUse.destinationX;
					gs.Map[x][y].occupyingUnit.destinationY=unitToUse.destinationY;
					
				}
			}
		}
	}
	
	public double DistanceBetweenTwoPoints(int x1,int y1,int x2,int y2){
	
		
		double value = Math.sqrt( (x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) );
		// System.out.println(value);
		if (value < 0){
			value=value*-1;
		}
		
		return value;
		
	}
	
        private void setGeometry() {
            GeometryDescriptor geomDesc = featureSource.getSchema().getGeometryDescriptor();
            geometryAttributeName = geomDesc.getLocalName();

            Class<?> clazz = geomDesc.getType().getBinding();

            if (Polygon.class.isAssignableFrom(clazz) ||
                    MultiPolygon.class.isAssignableFrom(clazz)) {
                geometryType = GeomType.POLYGON;

            } else if (LineString.class.isAssignableFrom(clazz) ||
                    MultiLineString.class.isAssignableFrom(clazz)) {

                geometryType = GeomType.LINE;

            } else {
                geometryType = GeomType.POINT;
            }

        }
    
	class ClientThread extends Thread {


		//Declare things
		// the socket where to listen/talk
		Socket socket;
		
		ObjectInputStream sInput;
		ObjectOutputStream sOutput;	
		BufferedOutputStream buffer;
		
		int id;		
		String username;
		
		ChatMessage cm;
		
		NetworkObject objectReceived;
		NetworkObject objectToSend;
		
		//Timestamp
		String date;
		
		boolean lockedIn =false;
		
		ClientThread(Socket socket) {
			
			
			id = ++uniqueId;
			totalConnections=totalConnections++;
			this.socket = socket;
			
			
			/* Creating both Data Stream */
			System.out.println("Creating Object Input/Output Streams");
			try
			{
				
				sOutput = new ObjectOutputStream(new BufferedOutputStream(socket.getOutputStream()));
				
				objectToSend= new NetworkObject(new ChatMessage(1,"Number of Locked Connections:" + lockedConnections));
				//objectToSend.gsToSend=gs;
				
				//write a null object to the client. TO brute force test connection.
				writeMsg(objectToSend);
				System.out.println("Object written");
				sInput = new ObjectInputStream(new BufferedInputStream(socket.getInputStream()));
				System.out.println("Input Stream Opened");
				// read the username that the client sends.
				
				objectReceived = (NetworkObject) sInput.readObject();
					
				username = (String) objectReceived.SentMessage.getMessage();
				int clientTeamNumber= objectReceived.clientTeamNumber;
				
				//check if username already exists.						
				int j;
				for ( j = 0; j < ClientNameList.size(); ++j ) {
					if (username.equals(ClientNameList.get(j))){
						//user has already joined before hand.
						username = username +"(1)";
					}
				
				}
				
				addNewStartingUnit(username, clientTeamNumber, id,false);
// 				gs.Map[0][id].occupyingUnit = new Unit(101,username);
// 				gs.Map[0][id].IFF = clientTeamNumber;
				ClientNameList.add(username);
				
				
				objectToSend= new NetworkObject(new ChatMessage(3,username));
				//objectToSend.gsToSend=gs;				
				writeMsg(objectToSend);
				
				
				
				System.out.println("UserName Received.");
				display(username + " just connected.");
				
				
				
			}
			catch (IOException e) {
				display("Exception creating new Input/output Streams: " + e);
				return;
			}
			catch(ClassNotFoundException e2) {
				display("class not found: " + e2);					
				
			}
			
			date = new Date().toString() + "\n";
			
				
				
		}

		//run the thread.
		
		//receive messages
		public void run() {

			updateBroadcast("");
			boolean keepGoing = true;
			while(keepGoing) {
				
				objectReceived=null;
				
				try {
					
					
					objectReceived = (NetworkObject) sInput.readObject();
					
					//System.out.println("I have just received " + objectReceived);
				}
				catch (IOException e) {
					display(username + " Exception reading Streams: " + e);
					keepGoing=false;
					break;
				}				
				catch(ClassNotFoundException e2) {
					display("class not found: " + e2);					
					
				}
				

				
				
				if (objectReceived.SentMessage !=null){
				
					
					cm = objectReceived.SentMessage;
				
					String message = cm.getMessage();
					
					switch(cm.getType()) {

						case ChatMessage.MESSAGE://broadcast message to all.
							broadcast(username + ": " + message);
							break;
						case ChatMessage.SETUSERNAME://broadcast message to all.
							display("Changing username: " +username + " to "+ message);
							username=message;							
							break;

						case ChatMessage.LOGOUT:
							display(username + " disconnected with a LOGOUT message.");
							keepGoing = false;
							
							break;
						case ChatMessage.LOCK:
							lockedIn =true;
							//gs = new GameState();
							updateBroadcast("");
							display(username +" is locked.");
							display(message);
							lockedConnections++;
							
							checkTurnsLockedIn();
							break;
						case ChatMessage.UNLOCK:
							lockedIn =false;
							lockedConnections--;
							
							break;
						case ChatMessage.UPDATE:
							
                                                        
                                                        
							receiveGameUpdate(objectReceived.unitTransferArray,objectReceived.clientID);
							
							lockedIn =true;
							lockedConnections++;
							checkTurnsLockedIn();
							
							//updateBroadcast("");
							
							break;
					}
					
				}
			}
			removePlayer(id);
			close();
		}

		// try to close everything
		private void close() {
			// try to close the connection
			try {
				if(sOutput != null) sOutput.close();
			}
			catch(Exception e) {}
			try {
				if(sInput != null) sInput.close();
			}
			catch(Exception e) {};
			try {
				if(socket != null) socket.close();
			}
			catch (Exception e) {}
		}
  
		//send messages
		private boolean writeMsg(NetworkObject msg) {
			
			if(!socket.isConnected()) {
				close();
				return false;
			}
			try {
				sOutput.reset();
				//clear buffer. helps a lot with networking stuff.				
				long startTime = System.currentTimeMillis();
				
				int readTotal = 0;
				
				sOutput.writeObject(msg);				
				sOutput.flush();
                                
				//clear buffer. helps a lot with networking stuff.
				sOutput.reset();
				long endTime = System.currentTimeMillis();
				
				//System.out.println(readTotal + " bytes written in " + (endTime - startTime) + " ms.");
				System.out.println("Message written in " + (endTime - startTime) + " ms.");
				
			
			}
			// if an error occurs, do not abort just inform the user
			catch(IOException e) {
				display("Error sending message to " + username);
				display(e.toString());
			}
			return true;
		}
	}
}


